	Section	Demo,Code

	Opt	C-,O+,w-
	
Start:	lea	$dff000,a5		; hardware base address

	Move.w	$1c(a5),OldInt	; Save Old Interupts
	Move.w	$02(a5),OldDma	; Save Old DMA

	Move.w	#$7fff,$9a(a5)	; Clear DMA
	Move.w	#$7fff,$96(a5)	; Clear Interupts
	Move.w	#$7fff,$9c(a5)	; Clear Interupt Requests
	
	Move.l	$6c.w,OldV3		; save level 3 int

	Move.l	#my_level3,$6c.w	; put new copper interupt
	Move.l	#my_copper,$80(a5) 	; Address of copper 1
	Move.w	#$e010,$9a(a5)	; Start interupts

	Move.w	#$83ef,$96(a5)	; Start DMA ( 83ff for disk dma)
	Move.w	#1,$88(a5)		; Strobe for copper start


	*********************************************

	move.l	4,a6		; execbase
	move.b	530(a6),d0		; execbase VBLANK_FREQUENCY

	MOVE.L	#1773447,D7 	; PAL CIA TIME
	
	cmp.b	#50,d0		; check if 50hz
	beq	_pal			
	
	MOVE.L	#1789773,D7 	; NTSC CIA TIME

_pal:	move.l	d7,deftime

	divu	#125,D7 		; Default to normal 50 Hz timer
	move.w	d7,ciatime

	move.l	$78,old		; store old level 6
	move.l	#l6int,$78		; install my level 6

	move.b	#$7f,$bfdd00	; all cia timers off
	move.b	#%00010001,$bfde00	; cra
	move.b	#%10000001,$bfdd00	; icr

	move.w	ciatime,d7

	MOVE.B	d7,$bfd400
	LSR.W	#8,D7
	MOVE.B	d7,$bfd500

	*********************************************

	move.l	#scr1,d0
	move.w	d0,bitplane0_lo
	swap	d0
	move.w	d0,bitplane0_hi
	swap	d0
	add.l	#26*203,d0
	move.w	d0,bitplane1_lo
	swap	d0
	move.w	d0,bitplane1_hi
	swap	d0
	add.l	#26*203,d0
	move.w	d0,bitplane2_lo
	swap	d0
	move.w	d0,bitplane2_hi
	swap	d0
	add.l	#26*203,d0
	move.w	d0,bitplane3_lo
	swap	d0
	move.w	d0,bitplane3_hi
	swap	d0
	add.l	#26*203,d0
	move.w	d0,bitplane4_lo
	swap	d0
	move.w	d0,bitplane4_hi


	bsr	mt_init

	st	mt_enable

wait:	btst	#6,$bfe001
	bne.s	wait		; wait for lmb

	lea	$dff000,a5		; hardware base address
	move.l	#0,$80(a5)		; blank copper list
	move.l	#0,$84(a5)		; if gfx lib not open (slayer boot)
	move.w	#0,$180(a5)		; bgc to black
	
	Move.l	OldV3,$6c.w		; restore old l3

	move.l	old,$78		; restore old level 6
	bsr	mt_end

	Lea	GfxLib,a1		; Pointer to Library Text
	move.l	4.w,a6
	jsr	-132(a6)		; forbid
	Move.l	4.w,a6		; Exec
	Moveq.l	#0,d0		; Clear D0
	Jsr	-$228(a6)		; Open Library
	cmp.l	#0,d0
	beq	no_gfx_lib		; if gfx lib not open dont restore copper lib (slayer boot)
	
	Move.l	d0,a1			
	Move.l	$26(a1),$80(a5)	; restore copper 1
	Move.l	$32(a1),$84(a5)	; restore copper 2
no_gfx_lib:

	Move.w	OldInt,d0		; start old interupts
	Or.w	#$8000,d0
	Move.w	d0,$9a(a5)
	Move.w	OldDma,d0		; start old DMA
	Or.w	#$8000,d0
	Move.w	d0,$96(a5)
	Move.b	#$9b,$bfed01	; Start Timers
	Move.l	4.w,a6		; Close Gfx lib
	Jsr	-$19e(a6)
	move.l	4.w,a6
	jsr	-138(a6)		; permit

	move.w	#0,$bfec00		; clear kbd

	Moveq.l	#0,d0		; No errors
	Rts			; Exit


my_level3:
	Movem.l	d0-d7/a0-a6,-(a7)	; New copper
	Move.w	#$10,$dff09c	; Serviced Interupt

	move.l	equ1list,a0
	lea	redcmap1+2,a1
	move.w	#14,d0
.loop1	move.w	(a0)+,(a1)
	add.l	#4,a1
	dbf	d0,.loop1

	move.l	equ2list,a0
	lea	bluecmap1+2,a1
	move.w	#14,d0
.loop2	move.w	(a0)+,(a1)
	add.l	#4,a1
	dbf	d0,.loop2

	move.l	equ3list,a0
	lea	redcmap2+2,a1
	move.w	#14,d0
.loop3	move.w	(a0)+,(a1)
	add.l	#4,a1
	dbf	d0,.loop3

	move.l	equ4list,a0
	lea	bluecmap2+2,a1
	move.w	#14,d0
.loop4	move.w	(a0)+,(a1)
	add.l	#4,a1
	dbf	d0,.loop4

	;sub.l	#1,delay
	;bpl	.noadd4

	;move.l	#0,delay

	move.l	equ1list,a0
	cmp.w	#0,(a0)
	beq	.noadd1
	add.l	#15*2,equ1list
.noadd1	move.l	equ2list,a0
	cmp.w	#0,(a0)
	beq	.noadd2
	add.l	#15*2,equ2list
.noadd2	move.l	equ3list,a0
	cmp.w	#0,(a0)
	beq	.noadd3
	add.l	#15*2,equ3list
.noadd3	move.l	equ4list,a0
	cmp.w	#0,(a0)
	beq	.noadd4
	add.l	#15*2,equ4list
.noadd4

Exit:	Movem.l	(a7)+,d0-d7/a0-a6
	Rte			; Return from Interupt

	****************************************************
	
l6int:	move.w	#$2000,$dff09c	; serviced interupt
	tst.b	$bfdd00		; restart timers

	add.b	#1,counter
	btst.b	#0,counter
	bne	.not
	
	;move.w	#$f00,$dff180

	bsr	mt_music

	;move.w	#$00f,$dff180

.not	rte

	*******************************************************

ciatime:		dc.l	0
deftime:		dc.l	0
old:		dc.l	0
counter:		dc.w	0

DMAWait = 300 ; Set this as low as possible without losing low notes.

;---- Tempo ----

SetTempo	cmp.w	#32,d0
	bhs.s	setemsk
	moveq	#32,d0
setemsk	move.w	d0,realtempo

	move.l	deftime,d2
	divu	d0,d2

	move.w	d2,ciatime

	move.b	d2,$bfd400
	lsr.w	#8,d2
	move.b	d2,$bfd500
	rts

RealTempo	dc.w 125

n_note		EQU	0  ; W
n_cmd		EQU	2  ; W
n_cmdlo		EQU	3  ; B
n_start		EQU	4  ; L
n_length		EQU	8  ; W
n_loopstart	EQU	10 ; L
n_replen		EQU	14 ; W
n_period		EQU	16 ; W
n_finetune	EQU	18 ; B
n_volume		EQU	19 ; B
n_dmabit		EQU	20 ; W
n_toneportdirec	EQU	22 ; B
n_toneportspeed	EQU	23 ; B
n_wantedperiod	EQU	24 ; W
n_vibratocmd	EQU	26 ; B
n_vibratopos	EQU	27 ; B
n_tremolocmd	EQU	28 ; B
n_tremolopos	EQU	29 ; B
n_wavecontrol	EQU	30 ; B
n_glissfunk	EQU	31 ; B
n_sampleoffset	EQU	32 ; B
n_pattpos	EQU	33 ; B
n_loopcount	EQU	34 ; B
n_funkoffset	EQU	35 ; B
n_wavestart	EQU	36 ; L
n_reallength	EQU	40 ; W

mt_extract:	movem.l	d0-d7/a0-a6,-(a7)

	divu	#30,d4

	Cmp.l	#$dff0a0,a5
	Bne.s	Mt_NN1
	bsr	mt_startlist
	move.l	d0,equ1list
Mt_NN1:	Cmp.l	#$dff0b0,a5
	Bne.s	Mt_NN2
	bsr	mt_startlist
	move.l	d0,equ2list
Mt_NN2:	Cmp.l	#$dff0c0,a5
	Bne.s	Mt_NN3
	bsr	mt_startlist
	move.l	d0,equ3list
Mt_NN3:	Cmp.l	#$dff0d0,a5
	Bne	Mt_NN4
	bsr	mt_startlist
	move.l	d0,equ4list
Mt_NN4:	movem.l	(a7)+,d0-d7/a0-a6
	rts

mt_startlist:	
	and.w	#7,d4
	asl.w	#2,d4
	lea	col_list,a0
	move.l	(a0,d4.w),d0
	rts
		
mt_init	lea	mt_data,A0
	MOVE.L	A0,mt_SongDataPtr
	MOVE.L	A0,A1
	LEA	952(A1),A1
	MOVEQ	#127,D0
	MOVEQ	#0,D1
mtloop	MOVE.L	D1,D2
	SUBQ.W	#1,D0
mtloop2	MOVE.B	(A1)+,D1
	CMP.B	D2,D1
	BGT.S	mtloop
	DBRA	D0,mtloop2
	ADDQ.B	#1,D2
			
	LEA	mt_SampleStarts(PC),A1
	ASL.L	#8,D2
	ASL.L	#2,D2
	ADD.L	#1084,D2
	ADD.L	A0,D2
	MOVE.L	D2,A2
	MOVEQ	#30,D0
mtloop3	CLR.L	(A2)
	MOVE.L	A2,(A1)+
	MOVEQ	#0,D1
	MOVE.W	42(A0),D1
	ASL.L	#1,D1
	ADD.L	D1,A2
	ADD.L	#30,A0
	DBRA	D0,mtloop3

	OR.B	#2,$BFE001
	MOVE.B	#6,mt_speed
	CLR.B	mt_counter
	CLR.B	mt_SongPos
	CLR.W	mt_PatternPos
mt_end	SF	mt_Enable
	LEA	$DFF000,A0
	CLR.W	$A8(A0)
	CLR.W	$B8(A0)
	CLR.W	$C8(A0)
	CLR.W	$D8(A0)
	MOVE.W	#$F,$DFF096
	RTS

mt_music
	MOVEM.L	D0-D4/A0-A6,-(SP)
	TST.B	mt_Enable
	BEQ	mt_exit
	ADDQ.B	#1,mt_counter
	MOVE.B	mt_counter(PC),D0
	CMP.B	mt_speed(PC),D0
	BLO.S	mt_NoNewNote
	CLR.B	mt_counter
	TST.B	mt_PattDelTime2
	BEQ.S	mt_GetNewNote
	BSR.S	mt_NoNewAllChannels
	BRA	mt_dskip

mt_NoNewNote
	BSR.S	mt_NoNewAllChannels
	BRA	mt_NoNewPosYet

mt_NoNewAllChannels
	LEA	$DFF0A0,A5
	LEA	mt_chan1temp(PC),A6
	BSR	mt_CheckEfx
	LEA	$DFF0B0,A5
	LEA	mt_chan2temp(PC),A6
	BSR	mt_CheckEfx
	LEA	$DFF0C0,A5
	LEA	mt_chan3temp(PC),A6
	BSR	mt_CheckEfx
	LEA	$DFF0D0,A5
	LEA	mt_chan4temp(PC),A6
	BRA	mt_CheckEfx

mt_GetNewNote
	MOVE.L	mt_SongDataPtr(PC),A0
	LEA	12(A0),A3
	LEA	952(A0),A2	;pattpo
	LEA	1084(A0),A0	;patterndata
	MOVEQ	#0,D0
	MOVEQ	#0,D1
	MOVE.B	mt_SongPos(PC),D0
	MOVE.B	(A2,D0.W),D1
	ASL.L	#8,D1
	ASL.L	#2,D1
	ADD.W	mt_PatternPos(PC),D1
	CLR.W	mt_DMACONtemp

	LEA	$DFF0A0,A5
	LEA	mt_chan1temp(PC),A6
	BSR	mt_PlayVoice
	
	LEA	$DFF0B0,A5
	LEA	mt_chan2temp(PC),A6
	BSR.S	mt_PlayVoice
	
	LEA	$DFF0C0,A5
	LEA	mt_chan3temp(PC),A6
	BSR.S	mt_PlayVoice
	
	LEA	$DFF0D0,A5
	LEA	mt_chan4temp(PC),A6
	BSR.S	mt_PlayVoice

	BRA	mt_SetDMA

mt_PlayVoice
	TST.L	(A6)
	BNE.S	mt_plvskip
	BSR	mt_PerNop
mt_plvskip
	MOVE.L	(A0,D1.L),(A6)
	ADDQ.L	#4,D1
	MOVEQ	#0,D2
	MOVE.B	n_cmd(A6),D2
	AND.B	#$F0,D2
	LSR.B	#4,D2
	MOVE.B	(A6),D0
	AND.B	#$F0,D0
	OR.B	D0,D2
	TST.B	D2
	BEQ	mt_SetRegs
	MOVEQ	#0,D3
	LEA	mt_SampleStarts(PC),A1
	MOVE	D2,D4
	SUBQ.L	#1,D2
	ASL.L	#2,D2
	MULU	#30,D4
	MOVE.L	(A1,D2.L),n_start(A6)
	MOVE.W	(A3,D4.L),n_length(A6)
	MOVE.W	(A3,D4.L),n_reallength(A6)
	MOVE.B	2(A3,D4.L),n_finetune(A6)
	MOVE.B	3(A3,D4.L),n_volume(A6)

	MOVE.W	4(A3,D4.L),D3		 ; Get repeat
	TST.W	D3
	BEQ.S	mt_NoLoop
	MOVE.L	n_start(A6),D2		; Get start
	ASL.W	#1,D3
	ADD.L	D3,D2			; Add repeat
	MOVE.L	D2,n_loopstart(A6)
	MOVE.L	D2,n_wavestart(A6)
	MOVE.W	4(A3,D4.L),D0		; Get repeat
	ADD.W	6(A3,D4.L),D0		; Add replen
	MOVE.W	D0,n_length(A6)
	MOVE.W	6(A3,D4.L),n_replen(A6)	; Save replen
	MOVEQ	#0,D0
	MOVE.B	n_volume(A6),D0
	MOVE.W	D0,8(A5)	; Set volume

	bsr	mt_extract
	
	BRA.S	mt_SetRegs

mt_NoLoop
	MOVE.L	n_start(A6),D2
	ADD.L	D3,D2
	MOVE.L	D2,n_loopstart(A6)
	MOVE.L	D2,n_wavestart(A6)
	MOVE.W	6(A3,D4.L),n_replen(A6)	; Save replen
	MOVEQ	#0,D0
	MOVE.B	n_volume(A6),D0
	MOVE.W	D0,8(A5)	; Set volume

	bsr	mt_extract

mt_SetRegs
	MOVE.W	(A6),D0
	AND.W	#$0FFF,D0
	BEQ	mt_CheckMoreEfx		; If no note
	MOVE.W	2(A6),D0
	AND.W	#$0FF0,D0
	CMP.W	#$0E50,D0
	BEQ.S	mt_DoSetFineTune
	MOVE.B	2(A6),D0
	AND.B	#$0F,D0
	CMP.B	#3,D0	; TonePortamento
	BEQ.S	mt_ChkTonePorta
	CMP.B	#5,D0
	BEQ.S	mt_ChkTonePorta
	CMP.B	#9,D0	; Sample Offset
	BNE.S	mt_SetPeriod
	BSR	mt_CheckMoreEfx
	BRA.S	mt_SetPeriod

mt_DoSetFineTune
	BSR	mt_SetFineTune
	BRA.S	mt_SetPeriod

mt_ChkTonePorta
	BSR	mt_SetTonePorta
	BRA	mt_CheckMoreEfx

mt_SetPeriod
	MOVEM.L	D0-D1/A0-A1,-(SP)
	MOVE.W	(A6),D1
	AND.W	#$0FFF,D1
	LEA	mt_PeriodTable(PC),A1
	MOVEQ	#0,D0
	MOVEQ	#36,D2
mt_ftuloop
	CMP.W	(A1,D0.W),D1
	BHS.S	mt_ftufound
	ADDQ.L	#2,D0
	DBRA	D2,mt_ftuloop
mt_ftufound
	MOVEQ	#0,D1
	MOVE.B	n_finetune(A6),D1
	MULU	#36*2,D1
	ADD.L	D1,A1
	MOVE.W	(A1,D0.W),n_period(A6)
	MOVEM.L	(SP)+,D0-D1/A0-A1

	MOVE.W	2(A6),D0
	AND.W	#$0FF0,D0
	CMP.W	#$0ED0,D0 ; Notedelay
	BEQ	mt_CheckMoreEfx

	MOVE.W	n_dmabit(A6),$DFF096
	BTST	#2,n_wavecontrol(A6)
	BNE.S	mt_vibnoc
	CLR.B	n_vibratopos(A6)
mt_vibnoc
	BTST	#6,n_wavecontrol(A6)
	BNE.S	mt_trenoc
	CLR.B	n_tremolopos(A6)
mt_trenoc
	MOVE.L	n_start(A6),(A5)		; Set start
	MOVE.W	n_length(A6),4(A5)	; Set length
	MOVE.W	n_period(A6),D0
	MOVE.W	D0,6(A5)			; Set period
	MOVE.W	n_dmabit(A6),D0
	OR.W	D0,mt_DMACONtemp
	BRA	mt_CheckMoreEfx
 
mt_SetDMA
	MOVE.W	#300,D0
mt_WaitDMA
	DBRA	D0,mt_WaitDMA
	MOVE.W	mt_DMACONtemp(PC),D0
	OR.W	#$8000,D0
	MOVE.W	D0,$DFF096
	MOVE.W	#300,D0
mt_WaitDMA2
	DBRA	D0,mt_WaitDMA2

	LEA	$DFF000,A5
	LEA	mt_chan4temp(PC),A6
	MOVE.L	n_loopstart(A6),$D0(A5)
	MOVE.W	n_replen(A6),$D4(A5)
	LEA	mt_chan3temp(PC),A6
	MOVE.L	n_loopstart(A6),$C0(A5)
	MOVE.W	n_replen(A6),$C4(A5)
	LEA	mt_chan2temp(PC),A6
	MOVE.L	n_loopstart(A6),$B0(A5)
	MOVE.W	n_replen(A6),$B4(A5)
	LEA	mt_chan1temp(PC),A6
	MOVE.L	n_loopstart(A6),$A0(A5)
	MOVE.W	n_replen(A6),$A4(A5)

mt_dskip
	ADD.W	#16,mt_PatternPos
	MOVE.B	mt_PattDelTime,D0
	BEQ.S	mt_dskc
	MOVE.B	D0,mt_PattDelTime2
	CLR.B	mt_PattDelTime
mt_dskc	TST.B	mt_PattDelTime2
	BEQ.S	mt_dska
	SUBQ.B	#1,mt_PattDelTime2
	BEQ.S	mt_dska
	SUB.W	#16,mt_PatternPos
mt_dska	TST.B	mt_PBreakFlag
	BEQ.S	mt_nnpysk
	SF	mt_PBreakFlag
	MOVEQ	#0,D0
	MOVE.B	mt_PBreakPos(PC),D0
	CLR.B	mt_PBreakPos
	LSL.W	#4,D0
	MOVE.W	D0,mt_PatternPos
mt_nnpysk
	CMP.W	#1024,mt_PatternPos
	BLO.S	mt_NoNewPosYet
mt_NextPosition	
	MOVEQ	#0,D0
	MOVE.B	mt_PBreakPos(PC),D0
	LSL.W	#4,D0
	MOVE.W	D0,mt_PatternPos
	CLR.B	mt_PBreakPos
	CLR.B	mt_PosJumpFlag
	ADDQ.B	#1,mt_SongPos
	AND.B	#$7F,mt_SongPos
	MOVE.B	mt_SongPos(PC),D1
	MOVE.L	mt_SongDataPtr(PC),A0
	CMP.B	950(A0),D1
	BLO.S	mt_NoNewPosYet
	CLR.B	mt_SongPos
mt_NoNewPosYet	
	TST.B	mt_PosJumpFlag
	BNE.S	mt_NextPosition
mt_exit	MOVEM.L	(SP)+,D0-D4/A0-A6
	RTS

mt_CheckEfx
	BSR	mt_UpdateFunk
	MOVE.W	n_cmd(A6),D0
	AND.W	#$0FFF,D0
	BEQ.S	mt_PerNop
	MOVE.B	n_cmd(A6),D0
	AND.B	#$0F,D0
	BEQ.S	mt_Arpeggio
	CMP.B	#1,D0
	BEQ	mt_PortaUp
	CMP.B	#2,D0
	BEQ	mt_PortaDown
	CMP.B	#3,D0
	BEQ	mt_TonePortamento
	CMP.B	#4,D0
	BEQ	mt_Vibrato
	CMP.B	#5,D0
	BEQ	mt_TonePlusVolSlide
	CMP.B	#6,D0
	BEQ	mt_VibratoPlusVolSlide
	CMP.B	#$E,D0
	BEQ	mt_E_Commands
SetBack	MOVE.W	n_period(A6),6(A5)
	CMP.B	#7,D0
	BEQ	mt_Tremolo
	CMP.B	#$A,D0
	BEQ	mt_VolumeSlide
mt_Return
	RTS

mt_PerNop
	MOVE.W	n_period(A6),6(A5)
	RTS

mt_Arpeggio
	MOVEQ	#0,D0
	MOVE.B	mt_counter(PC),D0
	DIVS	#3,D0
	SWAP	D0
	CMP.W	#0,D0
	BEQ.S	mt_Arpeggio2
	CMP.W	#2,D0
	BEQ.S	mt_Arpeggio1
	MOVEQ	#0,D0
	MOVE.B	n_cmdlo(A6),D0
	LSR.B	#4,D0
	BRA.S	mt_Arpeggio3

mt_Arpeggio1
	MOVEQ	#0,D0
	MOVE.B	n_cmdlo(A6),D0
	AND.B	#15,D0
	BRA.S	mt_Arpeggio3

mt_Arpeggio2
	MOVE.W	n_period(A6),D2
	BRA.S	mt_Arpeggio4

mt_Arpeggio3
	ASL.W	#1,D0
	MOVEQ	#0,D1
	MOVE.B	n_finetune(A6),D1
	MULU	#36*2,D1
	LEA	mt_PeriodTable(PC),A0
	ADD.L	D1,A0
	MOVEQ	#0,D1
	MOVE.W	n_period(A6),D1
	MOVEQ	#36,D3
mt_arploop
	MOVE.W	(A0,D0.W),D2
	CMP.W	(A0),D1
	BHS.S	mt_Arpeggio4
	ADDQ.L	#2,A0
	DBRA	D3,mt_arploop
	RTS

mt_Arpeggio4
	MOVE.W	D2,6(A5)
	RTS

mt_FinePortaUp
	TST.B	mt_counter
	BNE.S	mt_Return
	MOVE.B	#$0F,mt_LowMask
mt_PortaUp
	MOVEQ	#0,D0
	MOVE.B	n_cmdlo(A6),D0
	AND.B	mt_LowMask(PC),D0
	MOVE.B	#$FF,mt_LowMask
	SUB.W	D0,n_period(A6)
	MOVE.W	n_period(A6),D0
	AND.W	#$0FFF,D0
	CMP.W	#113,D0
	BPL.S	mt_PortaUskip
	AND.W	#$F000,n_period(A6)
	OR.W	#113,n_period(A6)
mt_PortaUskip
	MOVE.W	n_period(A6),D0
	AND.W	#$0FFF,D0
	MOVE.W	D0,6(A5)
	RTS	
 
mt_FinePortaDown
	TST.B	mt_counter
	BNE	mt_Return
	MOVE.B	#$0F,mt_LowMask
mt_PortaDown
	CLR.W	D0
	MOVE.B	n_cmdlo(A6),D0
	AND.B	mt_LowMask(PC),D0
	MOVE.B	#$FF,mt_LowMask
	ADD.W	D0,n_period(A6)
	MOVE.W	n_period(A6),D0
	AND.W	#$0FFF,D0
	CMP.W	#856,D0
	BMI.S	mt_PortaDskip
	AND.W	#$F000,n_period(A6)
	OR.W	#856,n_period(A6)
mt_PortaDskip
	MOVE.W	n_period(A6),D0
	AND.W	#$0FFF,D0
	MOVE.W	D0,6(A5)
	RTS

mt_SetTonePorta
	MOVE.L	A0,-(SP)
	MOVE.W	(A6),D2
	AND.W	#$0FFF,D2
	MOVEQ	#0,D0
	MOVE.B	n_finetune(A6),D0
	MULU	#37*2,D0
	LEA	mt_PeriodTable(PC),A0
	ADD.L	D0,A0
	MOVEQ	#0,D0
mt_StpLoop
	CMP.W	(A0,D0.W),D2
	BHS.S	mt_StpFound
	ADDQ.W	#2,D0
	CMP.W	#37*2,D0
	BLO.S	mt_StpLoop
	MOVEQ	#35*2,D0
mt_StpFound
	MOVE.B	n_finetune(A6),D2
	AND.B	#8,D2
	BEQ.S	mt_StpGoss
	TST.W	D0
	BEQ.S	mt_StpGoss
	SUBQ.W	#2,D0
mt_StpGoss
	MOVE.W	(A0,D0.W),D2
	MOVE.L	(SP)+,A0
	MOVE.W	D2,n_wantedperiod(A6)
	MOVE.W	n_period(A6),D0
	CLR.B	n_toneportdirec(A6)
	CMP.W	D0,D2
	BEQ.S	mt_ClearTonePorta
	BGE	mt_Return
	MOVE.B	#1,n_toneportdirec(A6)
	RTS

mt_ClearTonePorta
	CLR.W	n_wantedperiod(A6)
	RTS

mt_TonePortamento
	MOVE.B	n_cmdlo(A6),D0
	BEQ.S	mt_TonePortNoChange
	MOVE.B	D0,n_toneportspeed(A6)
	CLR.B	n_cmdlo(A6)
mt_TonePortNoChange
	TST.W	n_wantedperiod(A6)
	BEQ	mt_Return
	MOVEQ	#0,D0
	MOVE.B	n_toneportspeed(A6),D0
	TST.B	n_toneportdirec(A6)
	BNE.S	mt_TonePortaUp
mt_TonePortaDown
	ADD.W	D0,n_period(A6)
	MOVE.W	n_wantedperiod(A6),D0
	CMP.W	n_period(A6),D0
	BGT.S	mt_TonePortaSetPer
	MOVE.W	n_wantedperiod(A6),n_period(A6)
	CLR.W	n_wantedperiod(A6)
	BRA.S	mt_TonePortaSetPer

mt_TonePortaUp
	SUB.W	D0,n_period(A6)
	MOVE.W	n_wantedperiod(A6),D0
	CMP.W	n_period(A6),D0
	BLT.S	mt_TonePortaSetPer
	MOVE.W	n_wantedperiod(A6),n_period(A6)
	CLR.W	n_wantedperiod(A6)

mt_TonePortaSetPer
	MOVE.W	n_period(A6),D2
	MOVE.B	n_glissfunk(A6),D0
	AND.B	#$0F,D0
	BEQ.S	mt_GlissSkip
	MOVEQ	#0,D0
	MOVE.B	n_finetune(A6),D0
	MULU	#36*2,D0
	LEA	mt_PeriodTable(PC),A0
	ADD.L	D0,A0
	MOVEQ	#0,D0
mt_GlissLoop
	CMP.W	(A0,D0.W),D2
	BHS.S	mt_GlissFound
	ADDQ.W	#2,D0
	CMP.W	#36*2,D0
	BLO.S	mt_GlissLoop
	MOVEQ	#35*2,D0
mt_GlissFound
	MOVE.W	(A0,D0.W),D2
mt_GlissSkip
	MOVE.W	D2,6(A5) ; Set period
	RTS

mt_Vibrato
	MOVE.B	n_cmdlo(A6),D0
	BEQ.S	mt_Vibrato2
	MOVE.B	n_vibratocmd(A6),D2
	AND.B	#$0F,D0
	BEQ.S	mt_vibskip
	AND.B	#$F0,D2
	OR.B	D0,D2
mt_vibskip
	MOVE.B	n_cmdlo(A6),D0
	AND.B	#$F0,D0
	BEQ.S	mt_vibskip2
	AND.B	#$0F,D2
	OR.B	D0,D2
mt_vibskip2
	MOVE.B	D2,n_vibratocmd(A6)
mt_Vibrato2
	MOVE.B	n_vibratopos(A6),D0
	LEA	mt_VibratoTable(PC),A4
	LSR.W	#2,D0
	AND.W	#$001F,D0
	MOVEQ	#0,D2
	MOVE.B	n_wavecontrol(A6),D2
	AND.B	#$03,D2
	BEQ.S	mt_vib_sine
	LSL.B	#3,D0
	CMP.B	#1,D2
	BEQ.S	mt_vib_rampdown
	MOVE.B	#255,D2
	BRA.S	mt_vib_set
mt_vib_rampdown
	TST.B	n_vibratopos(A6)
	BPL.S	mt_vib_rampdown2
	MOVE.B	#255,D2
	SUB.B	D0,D2
	BRA.S	mt_vib_set
mt_vib_rampdown2
	MOVE.B	D0,D2
	BRA.S	mt_vib_set
mt_vib_sine
	MOVE.B	(A4,D0.W),D2
mt_vib_set
	MOVE.B	n_vibratocmd(A6),D0
	AND.W	#15,D0
	MULU	D0,D2
	LSR.W	#7,D2
	MOVE.W	n_period(A6),D0
	TST.B	n_vibratopos(A6)
	BMI.S	mt_VibratoNeg
	ADD.W	D2,D0
	BRA.S	mt_Vibrato3
mt_VibratoNeg
	SUB.W	D2,D0
mt_Vibrato3
	MOVE.W	D0,6(A5)
	MOVE.B	n_vibratocmd(A6),D0
	LSR.W	#2,D0
	AND.W	#$003C,D0
	ADD.B	D0,n_vibratopos(A6)
	RTS

mt_TonePlusVolSlide
	BSR	mt_TonePortNoChange
	BRA	mt_VolumeSlide

mt_VibratoPlusVolSlide
	BSR.S	mt_Vibrato2
	BRA	mt_VolumeSlide

mt_Tremolo
	MOVE.B	n_cmdlo(A6),D0
	BEQ.S	mt_Tremolo2
	MOVE.B	n_tremolocmd(A6),D2
	AND.B	#$0F,D0
	BEQ.S	mt_treskip
	AND.B	#$F0,D2
	OR.B	D0,D2
mt_treskip
	MOVE.B	n_cmdlo(A6),D0
	AND.B	#$F0,D0
	BEQ.S	mt_treskip2
	AND.B	#$0F,D2
	OR.B	D0,D2
mt_treskip2
	MOVE.B	D2,n_tremolocmd(A6)
mt_Tremolo2
	MOVE.B	n_tremolopos(A6),D0
	LEA	mt_VibratoTable(PC),A4
	LSR.W	#2,D0
	AND.W	#$001F,D0
	MOVEQ	#0,D2
	MOVE.B	n_wavecontrol(A6),D2
	LSR.B	#4,D2
	AND.B	#$03,D2
	BEQ.S	mt_tre_sine
	LSL.B	#3,D0
	CMP.B	#1,D2
	BEQ.S	mt_tre_rampdown
	MOVE.B	#255,D2
	BRA.S	mt_tre_set
mt_tre_rampdown
	TST.B	n_vibratopos(A6)
	BPL.S	mt_tre_rampdown2
	MOVE.B	#255,D2
	SUB.B	D0,D2
	BRA.S	mt_tre_set
mt_tre_rampdown2
	MOVE.B	D0,D2
	BRA.S	mt_tre_set
mt_tre_sine
	MOVE.B	(A4,D0.W),D2
mt_tre_set
	MOVE.B	n_tremolocmd(A6),D0
	AND.W	#15,D0
	MULU	D0,D2
	LSR.W	#6,D2
	MOVEQ	#0,D0
	MOVE.B	n_volume(A6),D0
	TST.B	n_tremolopos(A6)
	BMI.S	mt_TremoloNeg
	ADD.W	D2,D0
	BRA.S	mt_Tremolo3
mt_TremoloNeg
	SUB.W	D2,D0
mt_Tremolo3
	BPL.S	mt_TremoloSkip
	CLR.W	D0
mt_TremoloSkip
	CMP.W	#$40,D0
	BLS.S	mt_TremoloOk
	MOVE.W	#$40,D0
mt_TremoloOk
	MOVE.W	D0,8(A5)
	MOVE.B	n_tremolocmd(A6),D0
	LSR.W	#2,D0
	AND.W	#$003C,D0
	ADD.B	D0,n_tremolopos(A6)
	RTS

mt_SampleOffset
	MOVEQ	#0,D0
	MOVE.B	n_cmdlo(A6),D0
	BEQ.S	mt_sononew
	MOVE.B	D0,n_sampleoffset(A6)
mt_sononew
	MOVE.B	n_sampleoffset(A6),D0
	LSL.W	#7,D0
	CMP.W	n_length(A6),D0
	BGE.S	mt_sofskip
	SUB.W	D0,n_length(A6)
	LSL.W	#1,D0
	ADD.L	D0,n_start(A6)
	RTS
mt_sofskip
	MOVE.W	#$0001,n_length(A6)
	RTS

mt_VolumeSlide
	MOVEQ	#0,D0
	MOVE.B	n_cmdlo(A6),D0
	LSR.B	#4,D0
	TST.B	D0
	BEQ.S	mt_VolSlideDown
mt_VolSlideUp
	ADD.B	D0,n_volume(A6)
	CMP.B	#$40,n_volume(A6)
	BMI.S	mt_vsuskip
	MOVE.B	#$40,n_volume(A6)
mt_vsuskip
	MOVE.B	n_volume(A6),D0
	MOVE.W	D0,8(A5)
	RTS

mt_VolSlideDown
	MOVEQ	#0,D0
	MOVE.B	n_cmdlo(A6),D0
	AND.B	#$0F,D0
mt_VolSlideDown2
	SUB.B	D0,n_volume(A6)
	BPL.S	mt_vsdskip
	CLR.B	n_volume(A6)
mt_vsdskip
	MOVE.B	n_volume(A6),D0
	MOVE.W	D0,8(A5)
	RTS

mt_PositionJump
	MOVE.B	n_cmdlo(A6),D0
	SUBQ.B	#1,D0
	MOVE.B	D0,mt_SongPos
mt_pj2	CLR.B	mt_PBreakPos
	ST 	mt_PosJumpFlag
	RTS

mt_VolumeChange
	MOVEQ	#0,D0
	MOVE.B	n_cmdlo(A6),D0
	CMP.B	#$40,D0
	BLS.S	mt_VolumeOk
	MOVEQ	#$40,D0
mt_VolumeOk
	MOVE.B	D0,n_volume(A6)
	MOVE.W	D0,8(A5)
	RTS

mt_PatternBreak
	MOVEQ	#0,D0
	MOVE.B	n_cmdlo(A6),D0
	MOVE.L	D0,D2
	LSR.B	#4,D0
	MULU	#10,D0
	AND.B	#$0F,D2
	ADD.B	D2,D0
	CMP.B	#63,D0
	BHI.S	mt_pj2
	MOVE.B	D0,mt_PBreakPos
	ST	mt_PosJumpFlag
	RTS

mt_SetSpeed
	MOVEQ	#0,D0
	MOVE.B	3(A6),D0
	BEQ	mt_end
	CMP.B	#32,D0
	BHS	SetTempo
	CLR.B	mt_counter
	MOVE.B	D0,mt_speed
	RTS


mt_CheckMoreEfx
	BSR	mt_UpdateFunk
	MOVE.B	2(A6),D0
	AND.B	#$0F,D0
	CMP.B	#$9,D0
	BEQ	mt_SampleOffset
	CMP.B	#$B,D0
	BEQ	mt_PositionJump
	CMP.B	#$D,D0
	BEQ	mt_PatternBreak
	CMP.B	#$E,D0
	BEQ.S	mt_E_Commands
	CMP.B	#$F,D0
	BEQ	mt_SetSpeed
	CMP.B	#$C,D0
	BEQ	mt_VolumeChange
	BRA	mt_PerNop

mt_E_Commands
	MOVE.B	n_cmdlo(A6),D0
	AND.B	#$F0,D0
	LSR.B	#4,D0
	BEQ.S	mt_FilterOnOff
	CMP.B	#1,D0
	BEQ	mt_FinePortaUp
	CMP.B	#2,D0
	BEQ	mt_FinePortaDown
	CMP.B	#3,D0
	BEQ.S	mt_SetGlissControl
	CMP.B	#4,D0
	BEQ	mt_SetVibratoControl
	CMP.B	#5,D0
	BEQ	mt_SetFineTune
	CMP.B	#6,D0
	BEQ	mt_JumpLoop
	CMP.B	#7,D0
	BEQ	mt_SetTremoloControl
	CMP.B	#9,D0
	BEQ	mt_RetrigNote
	CMP.B	#$A,D0
	BEQ	mt_VolumeFineUp
	CMP.B	#$B,D0
	BEQ	mt_VolumeFineDown
	CMP.B	#$C,D0
	BEQ	mt_NoteCut
	CMP.B	#$D,D0
	BEQ	mt_NoteDelay
	CMP.B	#$E,D0
	BEQ	mt_PatternDelay
	CMP.B	#$F,D0
	BEQ	mt_FunkIt
	RTS

mt_FilterOnOff
	MOVE.B	n_cmdlo(A6),D0
	AND.B	#1,D0
	ASL.B	#1,D0
	AND.B	#$FD,$BFE001
	OR.B	D0,$BFE001
	RTS	

mt_SetGlissControl
	MOVE.B	n_cmdlo(A6),D0
	AND.B	#$0F,D0
	AND.B	#$F0,n_glissfunk(A6)
	OR.B	D0,n_glissfunk(A6)
	RTS

mt_SetVibratoControl
	MOVE.B	n_cmdlo(A6),D0
	AND.B	#$0F,D0
	AND.B	#$F0,n_wavecontrol(A6)
	OR.B	D0,n_wavecontrol(A6)
	RTS

mt_SetFineTune
	MOVE.B	n_cmdlo(A6),D0
	AND.B	#$0F,D0
	MOVE.B	D0,n_finetune(A6)
	RTS

mt_JumpLoop
	TST.B	mt_counter
	BNE	mt_Return
	MOVE.B	n_cmdlo(A6),D0
	AND.B	#$0F,D0
	BEQ.S	mt_SetLoop
	TST.B	n_loopcount(A6)
	BEQ.S	mt_jumpcnt
	SUBQ.B	#1,n_loopcount(A6)
	BEQ	mt_Return
mt_jmploop	MOVE.B	n_pattpos(A6),mt_PBreakPos
	ST	mt_PBreakFlag
	RTS

mt_jumpcnt
	MOVE.B	D0,n_loopcount(A6)
	BRA.S	mt_jmploop

mt_SetLoop
	MOVE.W	mt_PatternPos(PC),D0
	LSR.W	#4,D0
	MOVE.B	D0,n_pattpos(A6)
	RTS

mt_SetTremoloControl
	MOVE.B	n_cmdlo(A6),D0
	AND.B	#$0F,D0
	LSL.B	#4,D0
	AND.B	#$0F,n_wavecontrol(A6)
	OR.B	D0,n_wavecontrol(A6)
	RTS

mt_RetrigNote
	MOVE.L	D1,-(SP)
	MOVEQ	#0,D0
	MOVE.B	n_cmdlo(A6),D0
	AND.B	#$0F,D0
	BEQ.S	mt_rtnend
	MOVEQ	#0,D1
	MOVE.B	mt_counter(PC),D1
	BNE.S	mt_rtnskp
	MOVE.W	(A6),D1
	AND.W	#$0FFF,D1
	BNE.S	mt_rtnend
	MOVEQ	#0,D1
	MOVE.B	mt_counter(PC),D1
mt_rtnskp
	DIVU	D0,D1
	SWAP	D1
	TST.W	D1
	BNE.S	mt_rtnend
mt_DoRetrig
	MOVE.W	n_dmabit(A6),$DFF096	; Channel DMA off
	MOVE.L	n_start(A6),(A5)	; Set sampledata pointer
	MOVE.W	n_length(A6),4(A5)	; Set length
	MOVE.W	#300,D0
mt_rtnloop1
	DBRA	D0,mt_rtnloop1
	MOVE.W	n_dmabit(A6),D0
	BSET	#15,D0
	MOVE.W	D0,$DFF096
	MOVE.W	#300,D0
mt_rtnloop2
	DBRA	D0,mt_rtnloop2
	MOVE.L	n_loopstart(A6),(A5)
	MOVE.L	n_replen(A6),4(A5)
mt_rtnend
	MOVE.L	(SP)+,D1
	RTS

mt_VolumeFineUp
	TST.B	mt_counter
	BNE	mt_Return
	MOVEQ	#0,D0
	MOVE.B	n_cmdlo(A6),D0
	AND.B	#$F,D0
	BRA	mt_VolSlideUp

mt_VolumeFineDown
	TST.B	mt_counter
	BNE	mt_Return
	MOVEQ	#0,D0
	MOVE.B	n_cmdlo(A6),D0
	AND.B	#$0F,D0
	BRA	mt_VolSlideDown2

mt_NoteCut
	MOVEQ	#0,D0
	MOVE.B	n_cmdlo(A6),D0
	AND.B	#$0F,D0
	CMP.B	mt_counter(PC),D0
	BNE	mt_Return
	CLR.B	n_volume(A6)
	MOVE.W	#0,8(A5)
	RTS

mt_NoteDelay
	MOVEQ	#0,D0
	MOVE.B	n_cmdlo(A6),D0
	AND.B	#$0F,D0
	CMP.B	mt_Counter,D0
	BNE	mt_Return
	MOVE.W	(A6),D0
	BEQ	mt_Return
	MOVE.L	D1,-(SP)
	BRA	mt_DoRetrig

mt_PatternDelay
	TST.B	mt_counter
	BNE	mt_Return
	MOVEQ	#0,D0
	MOVE.B	n_cmdlo(A6),D0
	AND.B	#$0F,D0
	TST.B	mt_PattDelTime2
	BNE	mt_Return
	ADDQ.B	#1,D0
	MOVE.B	D0,mt_PattDelTime
	RTS

mt_FunkIt
	TST.B	mt_counter
	BNE	mt_Return
	MOVE.B	n_cmdlo(A6),D0
	AND.B	#$0F,D0
	LSL.B	#4,D0
	AND.B	#$0F,n_glissfunk(A6)
	OR.B	D0,n_glissfunk(A6)
	TST.B	D0
	BEQ	mt_Return
mt_UpdateFunk
	MOVEM.L	A0/D1,-(SP)
	MOVEQ	#0,D0
	MOVE.B	n_glissfunk(A6),D0
	LSR.B	#4,D0
	BEQ.S	mt_funkend
	LEA	mt_FunkTable(PC),A0
	MOVE.B	(A0,D0.W),D0
	ADD.B	D0,n_funkoffset(A6)
	BTST	#7,n_funkoffset(A6)
	BEQ.S	mt_funkend
	CLR.B	n_funkoffset(A6)

	MOVE.L	n_loopstart(A6),D0
	MOVEQ	#0,D1
	MOVE.W	n_replen(A6),D1
	ADD.L	D1,D0
	ADD.L	D1,D0
	MOVE.L	n_wavestart(A6),A0
	ADDQ.L	#1,A0
	CMP.L	D0,A0
	BLO.S	mt_funkok
	MOVE.L	n_loopstart(A6),A0
mt_funkok
	MOVE.L	A0,n_wavestart(A6)
	MOVEQ	#-1,D0
	SUB.B	(A0),D0
	MOVE.B	D0,(A0)
mt_funkend
	MOVEM.L	(SP)+,A0/D1
	RTS


mt_FunkTable dc.b 0,5,6,7,8,10,11,13,16,19,22,26,32,43,64,128

mt_VibratoTable	
	dc.b   0, 24, 49, 74, 97,120,141,161
	dc.b 180,197,212,224,235,244,250,253
	dc.b 255,253,250,244,235,224,212,197
	dc.b 180,161,141,120, 97, 74, 49, 24

mt_PeriodTable
; Tuning 0, Normal
	dc.w	856,808,762,720,678,640,604,570,538,508,480,453
	dc.w	428,404,381,360,339,320,302,285,269,254,240,226
	dc.w	214,202,190,180,170,160,151,143,135,127,120,113
; Tuning 1
	dc.w	850,802,757,715,674,637,601,567,535,505,477,450
	dc.w	425,401,379,357,337,318,300,284,268,253,239,225
	dc.w	213,201,189,179,169,159,150,142,134,126,119,113
; Tuning 2
	dc.w	844,796,752,709,670,632,597,563,532,502,474,447
	dc.w	422,398,376,355,335,316,298,282,266,251,237,224
	dc.w	211,199,188,177,167,158,149,141,133,125,118,112
; Tuning 3
	dc.w	838,791,746,704,665,628,592,559,528,498,470,444
	dc.w	419,395,373,352,332,314,296,280,264,249,235,222
	dc.w	209,198,187,176,166,157,148,140,132,125,118,111
; Tuning 4
	dc.w	832,785,741,699,660,623,588,555,524,495,467,441
	dc.w	416,392,370,350,330,312,294,278,262,247,233,220
	dc.w	208,196,185,175,165,156,147,139,131,124,117,110
; Tuning 5
	dc.w	826,779,736,694,655,619,584,551,520,491,463,437
	dc.w	413,390,368,347,328,309,292,276,260,245,232,219
	dc.w	206,195,184,174,164,155,146,138,130,123,116,109
; Tuning 6
	dc.w	820,774,730,689,651,614,580,547,516,487,460,434
	dc.w	410,387,365,345,325,307,290,274,258,244,230,217
	dc.w	205,193,183,172,163,154,145,137,129,122,115,109
; Tuning 7
	dc.w	814,768,725,684,646,610,575,543,513,484,457,431
	dc.w	407,384,363,342,323,305,288,272,256,242,228,216
	dc.w	204,192,181,171,161,152,144,136,128,121,114,108
; Tuning -8
	dc.w	907,856,808,762,720,678,640,604,570,538,508,480
	dc.w	453,428,404,381,360,339,320,302,285,269,254,240
	dc.w	226,214,202,190,180,170,160,151,143,135,127,120
; Tuning -7
	dc.w	900,850,802,757,715,675,636,601,567,535,505,477
	dc.w	450,425,401,379,357,337,318,300,284,268,253,238
	dc.w	225,212,200,189,179,169,159,150,142,134,126,119
; Tuning -6
	dc.w	894,844,796,752,709,670,632,597,563,532,502,474
	dc.w	447,422,398,376,355,335,316,298,282,266,251,237
	dc.w	223,211,199,188,177,167,158,149,141,133,125,118
; Tuning -5
	dc.w	887,838,791,746,704,665,628,592,559,528,498,470
	dc.w	444,419,395,373,352,332,314,296,280,264,249,235
	dc.w	222,209,198,187,176,166,157,148,140,132,125,118
; Tuning -4
	dc.w	881,832,785,741,699,660,623,588,555,524,494,467
	dc.w	441,416,392,370,350,330,312,294,278,262,247,233
	dc.w	220,208,196,185,175,165,156,147,139,131,123,117
; Tuning -3
	dc.w	875,826,779,736,694,655,619,584,551,520,491,463
	dc.w	437,413,390,368,347,328,309,292,276,260,245,232
	dc.w	219,206,195,184,174,164,155,146,138,130,123,116
; Tuning -2
	dc.w	868,820,774,730,689,651,614,580,547,516,487,460
	dc.w	434,410,387,365,345,325,307,290,274,258,244,230
	dc.w	217,205,193,183,172,163,154,145,137,129,122,115
; Tuning -1
	dc.w	862,814,768,725,684,646,610,575,543,513,484,457
	dc.w	431,407,384,363,342,323,305,288,272,256,242,228
	dc.w	216,203,192,181,171,161,152,144,136,128,121,114

mt_chan1temp	dc.l	0,0,0,0,0,$00010000,0,  0,0,0,0
mt_chan2temp	dc.l	0,0,0,0,0,$00020000,0,  0,0,0,0
mt_chan3temp	dc.l	0,0,0,0,0,$00040000,0,  0,0,0,0
mt_chan4temp	dc.l	0,0,0,0,0,$00080000,0,  0,0,0,0

mt_SampleStarts	dc.l	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
		dc.l	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

mt_SongDataPtr	dc.l 0
mt_speed	dc.b 6
mt_counter	dc.b 0
mt_SongPos	dc.b 0
mt_PBreakPos	dc.b 0
mt_PosJumpFlag	dc.b 0
mt_PBreakFlag	dc.b 0
mt_LowMask	dc.b 0
mt_PattDelTime	dc.b 0
mt_PattDelTime2	dc.b 0
mt_Enable	dc.b 0
mt_PatternPos	dc.w 0
mt_DMACONtemp	dc.w 0
ciatime2:	dc.l	0

;/* End of File */


	*******************************************************
oldint:		dc.l	0
olddma:		dc.l	0
oldv3:		dc.l	0
gfxlib:		dc.b	"graphics.library",0
		
delay:		dc.l	0		
		
equ1list:	dc.l	black_list
equ2list:	dc.l	black_list
equ3list:	dc.l	black_list
equ4list:	dc.l	black_list

black_list	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000

yellow_list:
	;dc.w	$ff0,$ff0,$ff0,$ff0,$ff0,$ff0,$ff0,$ff0,$ff0,$ff0,$ff0,$ff0,$ff0,$ff0,$ff0
	;dc.w	$ff0,$ff0,$ff0,$ff0,$ff0,$ff0,$ff0,$ff0,$ff0,$ff0,$ff0,$ff0,$ff0,$ff0,$ee0
	;dc.w	$ff0,$ff0,$ff0,$ff0,$ff0,$ff0,$ff0,$ff0,$ff0,$ff0,$ff0,$ff0,$ff0,$ee0,$dd0
	;dc.w	$ff0,$ff0,$ff0,$ff0,$ff0,$ff0,$ff0,$ff0,$ff0,$ff0,$ff0,$ff0,$ee0,$dd0,$cc0
	dc.w	$ff0,$ff0,$ff0,$ff0,$ff0,$ff0,$ff0,$ff0,$ff0,$ff0,$ff0,$ee0,$dd0,$cc0,$bb0
	dc.w	$ff0,$ff0,$ff0,$ff0,$ff0,$ff0,$ff0,$ff0,$ff0,$ff0,$ee0,$dd0,$cc0,$bb0,$aa0
	dc.w	$ff0,$ff0,$ff0,$ff0,$ff0,$ff0,$ff0,$ff0,$ff0,$ee0,$dd0,$cc0,$bb0,$aa0,$990
	dc.w	$ff0,$ff0,$ff0,$ff0,$ff0,$ff0,$ff0,$ff0,$ee0,$dd0,$cc0,$bb0,$aa0,$990,$880
	dc.w	$ff0,$ff0,$ff0,$ff0,$ff0,$ff0,$ff0,$ee0,$dd0,$cc0,$bb0,$aa0,$990,$880,$770
	dc.w	$ff0,$ff0,$ff0,$ff0,$ff0,$ff0,$ee0,$dd0,$cc0,$bb0,$aa0,$990,$880,$770,$660
	dc.w	$ff0,$ff0,$ff0,$ff0,$ff0,$ee0,$dd0,$cc0,$bb0,$aa0,$990,$880,$770,$660,$550
	dc.w	$ff0,$ff0,$ff0,$ff0,$ee0,$dd0,$cc0,$bb0,$aa0,$990,$880,$770,$660,$550,$440
	dc.w	$ff0,$ff0,$ff0,$ee0,$dd0,$cc0,$bb0,$aa0,$990,$880,$770,$660,$550,$440,$330
	dc.w	$ff0,$ff0,$ee0,$dd0,$cc0,$bb0,$aa0,$990,$880,$770,$660,$550,$440,$330,$220
	dc.w	$ff0,$ee0,$dd0,$cc0,$bb0,$aa0,$990,$880,$770,$660,$550,$440,$330,$220,$110
	dc.w	$ff0,$ee0,$dd0,$cc0,$bb0,$aa0,$990,$880,$770,$660,$550,$440,$330,$220,$110
	dc.w	$ee0,$dd0,$cc0,$bb0,$aa0,$990,$880,$770,$660,$550,$440,$330,$220,$110,$000
	dc.w	$dd0,$cc0,$bb0,$aa0,$990,$880,$770,$660,$550,$440,$330,$220,$110,$000,$000
	dc.w	$cc0,$bb0,$aa0,$990,$880,$770,$660,$550,$440,$330,$220,$110,$000,$000,$000
	dc.w	$bb0,$aa0,$990,$880,$770,$660,$550,$440,$330,$220,$110,$000,$000,$000,$000
	dc.w	$aa0,$990,$880,$770,$660,$550,$440,$330,$220,$110,$000,$000,$000,$000,$000
	dc.w	$990,$880,$770,$660,$550,$440,$330,$220,$110,$000,$000,$000,$000,$000,$000
	dc.w	$880,$770,$660,$550,$440,$330,$220,$110,$000,$000,$000,$000,$000,$000,$000
	dc.w	$770,$660,$550,$440,$330,$220,$110,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$660,$550,$440,$330,$220,$110,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$550,$440,$330,$220,$110,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$440,$330,$220,$110,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$330,$220,$110,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$220,$110,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$110,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000


red_list:	;dc.w	$f00,$f00,$f00,$f00,$f00,$f00,$f00,$f00,$f00,$f00,$f00,$f00,$f00,$f00,$f00
	;dc.w	$f00,$f00,$f00,$f00,$f00,$f00,$f00,$f00,$f00,$f00,$f00,$f00,$f00,$f00,$e00
	;dc.w	$f00,$f00,$f00,$f00,$f00,$f00,$f00,$f00,$f00,$f00,$f00,$f00,$f00,$e00,$d00
	;dc.w	$f00,$f00,$f00,$f00,$f00,$f00,$f00,$f00,$f00,$f00,$f00,$f00,$e00,$d00,$c00
	dc.w	$f00,$f00,$f00,$f00,$f00,$f00,$f00,$f00,$f00,$f00,$f00,$e00,$d00,$c00,$b00
	dc.w	$f00,$f00,$f00,$f00,$f00,$f00,$f00,$f00,$f00,$f00,$e00,$d00,$c00,$b00,$a00
	dc.w	$f00,$f00,$f00,$f00,$f00,$f00,$f00,$f00,$f00,$e00,$d00,$c00,$b00,$a00,$900
	dc.w	$f00,$f00,$f00,$f00,$f00,$f00,$f00,$f00,$e00,$d00,$c00,$b00,$a00,$900,$800
	dc.w	$f00,$f00,$f00,$f00,$f00,$f00,$f00,$e00,$d00,$c00,$b00,$a00,$900,$800,$700
	dc.w	$f00,$f00,$f00,$f00,$f00,$f00,$e00,$d00,$c00,$b00,$a00,$900,$800,$700,$600
	dc.w	$f00,$f00,$f00,$f00,$f00,$e00,$d00,$c00,$b00,$a00,$900,$800,$700,$600,$500
	dc.w	$f00,$f00,$f00,$f00,$e00,$d00,$c00,$b00,$a00,$900,$800,$700,$600,$500,$400
	dc.w	$f00,$f00,$f00,$e00,$d00,$c00,$b00,$a00,$900,$800,$700,$600,$500,$400,$300
	dc.w	$f00,$f00,$e00,$d00,$c00,$b00,$a00,$900,$800,$700,$600,$500,$400,$300,$200
	dc.w	$f00,$e00,$d00,$c00,$b00,$a00,$900,$800,$700,$600,$500,$400,$300,$200,$100		
	dc.w	$e00,$d00,$c00,$b00,$a00,$900,$800,$700,$600,$500,$400,$300,$200,$100,$000
	dc.w	$d00,$c00,$b00,$a00,$900,$800,$700,$600,$500,$400,$300,$200,$100,$000,$000
	dc.w	$c00,$b00,$a00,$900,$800,$700,$600,$500,$400,$300,$200,$100,$000,$000,$000
	dc.w	$b00,$a00,$900,$800,$700,$600,$500,$400,$300,$200,$100,$000,$000,$000,$000
	dc.w	$a00,$900,$800,$700,$600,$500,$400,$300,$200,$100,$000,$000,$000,$000,$000
	dc.w	$900,$800,$700,$600,$500,$400,$300,$200,$100,$000,$000,$000,$000,$000,$000
	dc.w	$800,$700,$600,$500,$400,$300,$200,$100,$000,$000,$000,$000,$000,$000,$000
	dc.w	$700,$600,$500,$400,$300,$200,$100,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$600,$500,$400,$300,$200,$100,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$500,$400,$300,$200,$100,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$400,$300,$200,$100,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$300,$200,$100,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$200,$100,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$100,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000


mag_list:	;dc.w	$f0f,$f0f,$f0f,$f0f,$f0f,$f0f,$f0f,$f0f,$f0f,$f0f,$f0f,$f0f,$f0f,$f0f,$f0f
	;dc.w	$f0f,$f0f,$f0f,$f0f,$f0f,$f0f,$f0f,$f0f,$f0f,$f0f,$f0f,$f0f,$f0f,$f0f,$e0e
	;dc.w	$f0f,$f0f,$f0f,$f0f,$f0f,$f0f,$f0f,$f0f,$f0f,$f0f,$f0f,$f0f,$f0f,$e0e,$d0d
	;dc.w	$f0f,$f0f,$f0f,$f0f,$f0f,$f0f,$f0f,$f0f,$f0f,$f0f,$f0f,$f0f,$e0e,$d0d,$c0c
	dc.w	$f0f,$f0f,$f0f,$f0f,$f0f,$f0f,$f0f,$f0f,$f0f,$f0f,$f0f,$e0e,$d0d,$c0c,$b0b
	dc.w	$f0f,$f0f,$f0f,$f0f,$f0f,$f0f,$f0f,$f0f,$f0f,$f0f,$e0e,$d0d,$c0c,$b0b,$a0a
	dc.w	$f0f,$f0f,$f0f,$f0f,$f0f,$f0f,$f0f,$f0f,$f0f,$e0e,$d0d,$c0c,$b0b,$a0a,$909
	dc.w	$f0f,$f0f,$f0f,$f0f,$f0f,$f0f,$f0f,$f0f,$e0e,$d0d,$c0c,$b0b,$a0a,$909,$808
	dc.w	$f0f,$f0f,$f0f,$f0f,$f0f,$f0f,$f0f,$e0e,$d0d,$c0c,$b0b,$a0a,$909,$808,$707
	dc.w	$f0f,$f0f,$f0f,$f0f,$f0f,$f0f,$e0e,$d0d,$c0c,$b0b,$a0a,$909,$808,$707,$606
	dc.w	$f0f,$f0f,$f0f,$f0f,$f0f,$e0e,$d0d,$c0c,$b0b,$a0a,$909,$808,$707,$606,$505
	dc.w	$f0f,$f0f,$f0f,$f0f,$e0e,$d0d,$c0c,$b0b,$a0a,$909,$808,$707,$606,$505,$404
	dc.w	$f0f,$f0f,$f0f,$e0e,$d0d,$c0c,$b0b,$a0a,$909,$808,$707,$606,$505,$404,$303
	dc.w	$f0f,$f0f,$e0e,$d0d,$c0c,$b0b,$a0a,$909,$808,$707,$606,$505,$404,$303,$202
	dc.w	$f0f,$e0e,$d0d,$c0c,$b0b,$a0a,$909,$808,$707,$606,$505,$404,$303,$202,$101
	dc.w	$f0f,$e0e,$d0d,$c0c,$b0b,$a0a,$909,$808,$707,$606,$505,$404,$303,$202,$101
	dc.w	$e0e,$d0d,$c0c,$b0b,$a0a,$909,$808,$707,$606,$505,$404,$303,$202,$101,$000
	dc.w	$d0d,$c0c,$b0b,$a0a,$909,$808,$707,$606,$505,$404,$303,$202,$101,$000,$000
	dc.w	$c0c,$b0b,$a0a,$909,$808,$707,$606,$505,$404,$303,$202,$101,$000,$000,$000
	dc.w	$b0b,$a0a,$909,$808,$707,$606,$505,$404,$303,$202,$101,$000,$000,$000,$000
	dc.w	$a0a,$909,$808,$707,$606,$505,$404,$303,$202,$101,$000,$000,$000,$000,$000
	dc.w	$909,$808,$707,$606,$505,$404,$303,$202,$101,$000,$000,$000,$000,$000,$000
	dc.w	$808,$707,$606,$505,$404,$303,$202,$101,$000,$000,$000,$000,$000,$000,$000
	dc.w	$707,$606,$505,$404,$303,$202,$101,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$606,$505,$404,$303,$202,$101,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$505,$404,$303,$202,$101,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$404,$303,$202,$101,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$303,$202,$101,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$202,$101,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$101,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000

green_list:	;dc.w	$0f0,$0f0,$0f0,$0f0,$0f0,$0f0,$0f0,$0f0,$0f0,$0f0,$0f0,$0f0,$0f0,$0f0,$0f0
	;dc.w	$0f0,$0f0,$0f0,$0f0,$0f0,$0f0,$0f0,$0f0,$0f0,$0f0,$0f0,$0f0,$0f0,$0f0,$0e0
	;dc.w	$0f0,$0f0,$0f0,$0f0,$0f0,$0f0,$0f0,$0f0,$0f0,$0f0,$0f0,$0f0,$0f0,$0e0,$0d0
	;dc.w	$0f0,$0f0,$0f0,$0f0,$0f0,$0f0,$0f0,$0f0,$0f0,$0f0,$0f0,$0f0,$0e0,$0d0,$0c0
	dc.w	$0f0,$0f0,$0f0,$0f0,$0f0,$0f0,$0f0,$0f0,$0f0,$0f0,$0f0,$0e0,$0d0,$0c0,$0b0
	dc.w	$0f0,$0f0,$0f0,$0f0,$0f0,$0f0,$0f0,$0f0,$0f0,$0f0,$0e0,$0d0,$0c0,$0b0,$0a0
	dc.w	$0f0,$0f0,$0f0,$0f0,$0f0,$0f0,$0f0,$0f0,$0f0,$0e0,$0d0,$0c0,$0b0,$0a0,$090
	dc.w	$0f0,$0f0,$0f0,$0f0,$0f0,$0f0,$0f0,$0f0,$0e0,$0d0,$0c0,$0b0,$0a0,$090,$080
	dc.w	$0f0,$0f0,$0f0,$0f0,$0f0,$0f0,$0f0,$0e0,$0d0,$0c0,$0b0,$0a0,$090,$080,$070
	dc.w	$0f0,$0f0,$0f0,$0f0,$0f0,$0f0,$0e0,$0d0,$0c0,$0b0,$0a0,$090,$080,$070,$060
	dc.w	$0f0,$0f0,$0f0,$0f0,$0f0,$0e0,$0d0,$0c0,$0b0,$0a0,$090,$080,$070,$060,$050
	dc.w	$0f0,$0f0,$0f0,$0f0,$0e0,$0d0,$0c0,$0b0,$0a0,$090,$080,$070,$060,$050,$040
	dc.w	$0f0,$0f0,$0f0,$0e0,$0d0,$0c0,$0b0,$0a0,$090,$080,$070,$060,$050,$040,$030
	dc.w	$0f0,$0f0,$0e0,$0d0,$0c0,$0b0,$0a0,$090,$080,$070,$060,$050,$040,$030,$020
	dc.w	$0f0,$0e0,$0d0,$0c0,$0b0,$0a0,$090,$080,$070,$060,$050,$040,$030,$020,$010
	dc.w	$0f0,$0e0,$0d0,$0c0,$0b0,$0a0,$090,$080,$070,$060,$050,$040,$030,$020,$010
	dc.w	$0e0,$0d0,$0c0,$0b0,$0a0,$090,$080,$070,$060,$050,$040,$030,$020,$010,$000
	dc.w	$0d0,$0c0,$0b0,$0a0,$090,$080,$070,$060,$050,$040,$030,$020,$010,$000,$000
	dc.w	$0c0,$0b0,$0a0,$090,$080,$070,$060,$050,$040,$030,$020,$010,$000,$000,$000
	dc.w	$0b0,$0a0,$090,$080,$070,$060,$050,$040,$030,$020,$010,$000,$000,$000,$000
	dc.w	$0a0,$090,$080,$070,$060,$050,$040,$030,$020,$010,$000,$000,$000,$000,$000
	dc.w	$090,$080,$070,$060,$050,$040,$030,$020,$010,$000,$000,$000,$000,$000,$000
	dc.w	$080,$070,$060,$050,$040,$030,$020,$010,$000,$000,$000,$000,$000,$000,$000
	dc.w	$070,$060,$050,$040,$030,$020,$010,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$060,$050,$040,$030,$020,$010,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$050,$040,$030,$020,$010,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$040,$030,$020,$010,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$030,$020,$010,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$020,$010,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$010,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000

cyan_list:	;dc.w	$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF
	;dc.w	$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0EE
	;dc.w	$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0EE,$0DD
	;dc.w	$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0EE,$0DD,$0CC
	dc.w	$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0EE,$0DD,$0CC,$0BB
	dc.w	$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0EE,$0DD,$0CC,$0BB,$0AA
	dc.w	$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0EE,$0DD,$0CC,$0BB,$0AA,$099
	dc.w	$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0EE,$0DD,$0CC,$0BB,$0AA,$099,$088
	dc.w	$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0EE,$0DD,$0CC,$0BB,$0AA,$099,$088,$077
	dc.w	$0FF,$0FF,$0FF,$0FF,$0FF,$0FF,$0EE,$0DD,$0CC,$0BB,$0AA,$099,$088,$077,$066
	dc.w	$0FF,$0FF,$0FF,$0FF,$0FF,$0EE,$0DD,$0CC,$0BB,$0AA,$099,$088,$077,$066,$055
	dc.w	$0FF,$0FF,$0FF,$0FF,$0EE,$0DD,$0CC,$0BB,$0AA,$099,$088,$077,$066,$055,$044
	dc.w	$0FF,$0FF,$0FF,$0EE,$0DD,$0CC,$0BB,$0AA,$099,$088,$077,$066,$055,$044,$033
	dc.w	$0FF,$0FF,$0EE,$0DD,$0CC,$0BB,$0AA,$099,$088,$077,$066,$055,$044,$033,$022
	dc.w	$0FF,$0EE,$0DD,$0CC,$0BB,$0AA,$099,$088,$077,$066,$055,$044,$033,$022,$011
	dc.w	$0FF,$0EE,$0DD,$0CC,$0BB,$0AA,$099,$088,$077,$066,$055,$044,$033,$022,$011
	dc.w	$0EE,$0DD,$0CC,$0BB,$0AA,$099,$088,$077,$066,$055,$044,$033,$022,$011,$000
	dc.w	$0DD,$0CC,$0BB,$0AA,$099,$088,$077,$066,$055,$044,$033,$022,$011,$000,$000
	dc.w	$0CC,$0BB,$0AA,$099,$088,$077,$066,$055,$044,$033,$022,$011,$000,$000,$000
	dc.w	$0BB,$0AA,$099,$088,$077,$066,$055,$044,$033,$022,$011,$000,$000,$000,$000
	dc.w	$0AA,$099,$088,$077,$066,$055,$044,$033,$022,$011,$000,$000,$000,$000,$000
	dc.w	$099,$088,$077,$066,$055,$044,$033,$022,$011,$000,$000,$000,$000,$000,$000
	dc.w	$088,$077,$066,$055,$044,$033,$022,$011,$000,$000,$000,$000,$000,$000,$000
	dc.w	$077,$066,$055,$044,$033,$022,$011,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$066,$055,$044,$033,$022,$011,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$055,$044,$033,$022,$011,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$044,$033,$022,$011,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$033,$022,$011,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$022,$011,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$011,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000

white_list:	;dc.w	$FFF,$FFF,$FFF,$FFF,$FFF,$FFF,$FFF,$FFF,$FFF,$FFF,$FFF,$FFF,$FFF,$FFF,$FFF
	;dc.w	$FFF,$FFF,$FFF,$FFF,$FFF,$FFF,$FFF,$FFF,$FFF,$FFF,$FFF,$FFF,$FFF,$FFF,$EEE
	;dc.w	$FFF,$FFF,$FFF,$FFF,$FFF,$FFF,$FFF,$FFF,$FFF,$FFF,$FFF,$FFF,$FFF,$EEE,$DDD
	;dc.w	$FFF,$FFF,$FFF,$FFF,$FFF,$FFF,$FFF,$FFF,$FFF,$FFF,$FFF,$FFF,$EEE,$DDD,$CCC
	dc.w	$FFF,$FFF,$FFF,$FFF,$FFF,$FFF,$FFF,$FFF,$FFF,$FFF,$FFF,$EEE,$DDD,$CCC,$BBB
	dc.w	$FFF,$FFF,$FFF,$FFF,$FFF,$FFF,$FFF,$FFF,$FFF,$FFF,$EEE,$DDD,$CCC,$BBB,$AAA
	dc.w	$FFF,$FFF,$FFF,$FFF,$FFF,$FFF,$FFF,$FFF,$FFF,$EEE,$DDD,$CCC,$BBB,$AAA,$999
	dc.w	$FFF,$FFF,$FFF,$FFF,$FFF,$FFF,$FFF,$FFF,$EEE,$DDD,$CCC,$BBB,$AAA,$999,$888
	dc.w	$FFF,$FFF,$FFF,$FFF,$FFF,$FFF,$FFF,$EEE,$DDD,$CCC,$BBB,$AAA,$999,$888,$777
	dc.w	$FFF,$FFF,$FFF,$FFF,$FFF,$FFF,$EEE,$DDD,$CCC,$BBB,$AAA,$999,$888,$777,$666
	dc.w	$FFF,$FFF,$FFF,$FFF,$FFF,$EEE,$DDD,$CCC,$BBB,$AAA,$999,$888,$777,$666,$555
	dc.w	$FFF,$FFF,$FFF,$FFF,$EEE,$DDD,$CCC,$BBB,$AAA,$999,$888,$777,$666,$555,$444
	dc.w	$FFF,$FFF,$FFF,$EEE,$DDD,$CCC,$BBB,$AAA,$999,$888,$777,$666,$555,$444,$333
	dc.w	$FFF,$FFF,$EEE,$DDD,$CCC,$BBB,$AAA,$999,$888,$777,$666,$555,$444,$333,$222
	dc.w	$FFF,$EEE,$DDD,$CCC,$BBB,$AAA,$999,$888,$777,$666,$555,$444,$333,$222,$111
	dc.w	$FFF,$EEE,$DDD,$CCC,$BBB,$AAA,$999,$888,$777,$666,$555,$444,$333,$222,$111
	dc.w	$EEE,$DDD,$CCC,$BBB,$AAA,$999,$888,$777,$666,$555,$444,$333,$222,$111,$000
	dc.w	$DDD,$CCC,$BBB,$AAA,$999,$888,$777,$666,$555,$444,$333,$222,$111,$000,$000
	dc.w	$CCC,$BBB,$AAA,$999,$888,$777,$666,$555,$444,$333,$222,$111,$000,$000,$000
	dc.w	$BBB,$AAA,$999,$888,$777,$666,$555,$444,$333,$222,$111,$000,$000,$000,$000
	dc.w	$AAA,$999,$888,$777,$666,$555,$444,$333,$222,$111,$000,$000,$000,$000,$000
	dc.w	$999,$888,$777,$666,$555,$444,$333,$222,$111,$000,$000,$000,$000,$000,$000
	dc.w	$888,$777,$666,$555,$444,$333,$222,$111,$000,$000,$000,$000,$000,$000,$000
	dc.w	$777,$666,$555,$444,$333,$222,$111,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$666,$555,$444,$333,$222,$111,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$555,$444,$333,$222,$111,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$444,$333,$222,$111,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$333,$222,$111,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$222,$111,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$111,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000

blue_list:	;dc.w	$00F,$00F,$00F,$00F,$00F,$00F,$00F,$00F,$00F,$00F,$00F,$00F,$00F,$00F,$00F
	;dc.w	$00F,$00F,$00F,$00F,$00F,$00F,$00F,$00F,$00F,$00F,$00F,$00F,$00F,$00F,$00E
	;dc.w	$00F,$00F,$00F,$00F,$00F,$00F,$00F,$00F,$00F,$00F,$00F,$00F,$00F,$00E,$00D
	;dc.w	$00F,$00F,$00F,$00F,$00F,$00F,$00F,$00F,$00F,$00F,$00F,$00F,$00E,$00D,$00C
	dc.w	$00F,$00F,$00F,$00F,$00F,$00F,$00F,$00F,$00F,$00F,$00F,$00E,$00D,$00C,$00B
	dc.w	$00F,$00F,$00F,$00F,$00F,$00F,$00F,$00F,$00F,$00F,$00E,$00D,$00C,$00B,$00A
	dc.w	$00F,$00F,$00F,$00F,$00F,$00F,$00F,$00F,$00F,$00E,$00D,$00C,$00B,$00A,$009
	dc.w	$00F,$00F,$00F,$00F,$00F,$00F,$00F,$00F,$00E,$00D,$00C,$00B,$00A,$009,$008
	dc.w	$00F,$00F,$00F,$00F,$00F,$00F,$00F,$00E,$00D,$00C,$00B,$00A,$009,$008,$007
	dc.w	$00F,$00F,$00F,$00F,$00F,$00F,$00E,$00D,$00C,$00B,$00A,$009,$008,$007,$006
	dc.w	$00F,$00F,$00F,$00F,$00F,$00E,$00D,$00C,$00B,$00A,$009,$008,$007,$006,$005
	dc.w	$00F,$00F,$00F,$00F,$00E,$00D,$00C,$00B,$00A,$009,$008,$007,$006,$005,$004
	dc.w	$00F,$00F,$00F,$00E,$00D,$00C,$00B,$00A,$009,$008,$007,$006,$005,$004,$003
	dc.w	$00F,$00F,$00E,$00D,$00C,$00B,$00A,$009,$008,$007,$006,$005,$004,$003,$002
	dc.w	$00F,$00E,$00D,$00C,$00B,$00A,$009,$008,$007,$006,$005,$004,$003,$002,$001
	dc.w	$00F,$00E,$00D,$00C,$00B,$00A,$009,$008,$007,$006,$005,$004,$003,$002,$001
	dc.w	$00E,$00D,$00C,$00B,$00A,$009,$008,$007,$006,$005,$004,$003,$002,$001,$000
	dc.w	$00D,$00C,$00B,$00A,$009,$008,$007,$006,$005,$004,$003,$002,$001,$000,$000
	dc.w	$00C,$00B,$00A,$009,$008,$007,$006,$005,$004,$003,$002,$001,$000,$000,$000
	dc.w	$00B,$00A,$009,$008,$007,$006,$005,$004,$003,$002,$001,$000,$000,$000,$000
	dc.w	$00A,$009,$008,$007,$006,$005,$004,$003,$002,$001,$000,$000,$000,$000,$000
	dc.w	$009,$008,$007,$006,$005,$004,$003,$002,$001,$000,$000,$000,$000,$000,$000
	dc.w	$008,$007,$006,$005,$004,$003,$002,$001,$000,$000,$000,$000,$000,$000,$000
	dc.w	$007,$006,$005,$004,$003,$002,$001,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$006,$005,$004,$003,$002,$001,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$005,$004,$003,$002,$001,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$004,$003,$002,$001,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$003,$002,$001,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$002,$001,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$001,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000
	dc.w	$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000,$000

col_list:		dc.l	yellow_list
		dc.l	red_list
		dc.l	mag_list
		dc.l	green_list
		dc.l	cyan_list
		dc.l	white_list
		dc.l	blue_list
		dc.l	red_list

	section	copperstuff,data_c
	
my_copper:	
		dc.w	$100,$5200	; 4 bp - lo res
		dc.w	$104,$a		; bp control reg
		dc.w	$108,0		; bp modulo - odd
		dc.w	$10a,0		; bp modulo - even
		dc.w	$180,0		; colour 0 to black
		dc.w	$102,0
		
		dc.w	$08e,$2c81	; bp window start left
		dc.w	$090,$2cc1	; bp window bot right

		dc.w	$94,$b0	; bp stop horz
		dc.w	$92,$50
		
		dc.w	$120,0,$122,0,$124,0,$126,0
		dc.w	$128,0,$12a,0,$12c,0,$12e,0
		dc.w	$130,0,$132,0,$134,0,$136,0
		dc.w	$138,0,$13a,0,$13c,0,$13e,0
		
		dc.w	$1a0,$000

		dc.w	  $e0
bitplane0_hi:	dc.w	0,$e2
bitplane0_lo:	dc.w	0,$e4
bitplane1_hi:	dc.w	0,$e6
bitplane1_lo:	dc.w	0,$e8
bitplane2_hi:	dc.w	0,$ea
bitplane2_lo:	dc.w	0,$ec
bitplane3_hi:	dc.w	0,$ee
bitplane3_lo:	dc.w	0,$f0
bitplane4_hi:	dc.w	0,$f2
bitplane4_lo:	dc.w	0
		
redcmap1:		dc.w	$182,$000
		dc.w	$184,$000
		dc.w	$186,$000
		dc.w	$188,$000
		dc.w	$18a,$000
		dc.w	$18c,$000
		dc.w	$18e,$000
		dc.w	$190,$000
		dc.w	$192,$000
		dc.w	$194,$000
		dc.w	$196,$000
		dc.w	$198,$000
		dc.w	$19a,$000
		dc.w	$19c,$000
		dc.w	$19e,$000

bluecmap1:		dc.w	$1a2,$000
		dc.w	$1a4,$000
		dc.w	$1a6,$000
		dc.w	$1a8,$000
		dc.w	$1aa,$000
		dc.w	$1ac,$000
		dc.w	$1ae,$000
		dc.w	$1b0,$000
		dc.w	$1b2,$000
		dc.w	$1b4,$000
		dc.w	$1b6,$000
		dc.w	$1b8,$000
		dc.w	$1ba,$000
		dc.w	$1bc,$000
		dc.w	$1be,$000

		dc.w	$9091,$fffe

redcmap2:		dc.w	$182,$000
		dc.w	$184,$000
		dc.w	$186,$000
		dc.w	$188,$000
		dc.w	$18a,$000
		dc.w	$18c,$000
		dc.w	$18e,$000
		dc.w	$190,$000
		dc.w	$192,$000
		dc.w	$194,$000
		dc.w	$196,$000
		dc.w	$198,$000
		dc.w	$19a,$000
		dc.w	$19c,$000
		dc.w	$19e,$000

bluecmap2:		dc.w	$1a2,$000
		dc.w	$1a4,$000
		dc.w	$1a6,$000
		dc.w	$1a8,$000
		dc.w	$1aa,$000
		dc.w	$1ac,$000
		dc.w	$1ae,$000
		dc.w	$1b0,$000
		dc.w	$1b2,$000
		dc.w	$1b4,$000
		dc.w	$1b6,$000
		dc.w	$1b8,$000
		dc.w	$1ba,$000
		dc.w	$1bc,$000
		dc.w	$1be,$000

		dc.w	$f801,$fffe,$100,$0200

		dc.w	$ffe1,$fffe	; end of ntsc screen
		dc.w	$3001,$ff00	; end of pal screen
		dc.w	$9c,$8010	; irq set bits - restart copper
		dc.w	$ffff,$fffe	; end of copper list


scr1:		incbin	"dh0:data/requal/round1_small.bin"

mt_data:		incbin	"dh0:data/technofever/mod.techno fever #06"
		incbin	"dh0:data/totalkaos/mods/mod.total kaos #07"
	end
	



